jQuery.fn.player = function () {

	var o		= this,
		title	= $(this).find('#title'),
		index	= $(this).find('#index'),
		author	= $(this).find('#author'),
		player	= $(this).find('#player');

	var c = jQuery.fn.player.config;
	var i = jQuery.fn.player.config.index;

	var l = jQuery.fn.player.language;

	return this.each(function(){
		var _, hint;

		/* title */

		_ = $('<div>', { 'text' : c.title });

		hint = new Array();

		if (c.author.name)	hint.push(c.author.name);
		if (c.duration)		hint.push(c.duration);

		_.append($('<span>', {
			'class' : 'hint',
			'text' : ' (' + hint.join(', ') + ')'
		}))

		$('#title').html(_);

		/* index */

		if (c.author.photo) {
			author.append(
				$('<img>', {
					'src' : c.author.photo
				})
			);

		}

		var list = new Array();
		var sn1 = 0,
			sn2 = 0;

		$.each(i, function(idx, itm){

			var li = $('<li>', {
				'class'	: 'idx',
				'role'	: 'idx',
				'sn'	: idx,
				'time'	: itm.time,
				'title'	: itm.title
			});

			if (itm.indent == true) {
				li.toggleClass('indent', true);
				sn2++;
			} else {
				sn1++;
				sn2 = 0;
			}

			var sn = (sn2 != 0)
				? sn1 + '.' + sn2
				: sn1 + '.';

			li.text(sn + ' ' + itm.title);
			list.push(li);
		});

		index.append($('<ul>', {append:list}));

		$(function(){

			player.bind('index.change', function(e, obj){

				$("[role='idx']").toggleClass('curr', false);
				$("[role='idx'][sn='" + obj.sn + "']").toggleClass('curr', true);
			});

			$('[role="idx"]').click(function(){
				player.trigger('index.to', {time:$(this).attr('time'), sn:$(this).attr('sn')});
			});
		});

		var m = c.duration.split(':');

		if (m.length == 2)
			var duration = (60*parseInt(m[0], 10) + parseInt(m[1], 10));

		if (m.length == 3)
			var duration = (3600*parseInt(m[0], 10) + 60*parseInt(m[1], 10) + parseInt(m[2], 10));

		player.jQPlayer({
			subtitle: true,
			controls: ['separator', 'play', 'separator', 'progress', 'volume',  'fullscreen', 'time', 'separator'],
			duration: duration*1000,
			videos: {
				'video': {
					source: {
						mp4: c.source
					},
					subtitle: i
				}
			},
			defaultVideo: 'video',
			onVideoReady: function(){
				player.find('video').css({
					'max-width'	: c.width + 'px',
					'max-height': c.height + 'px'
				});
			},
			onStart : function(){
				player.find('video').bind('canplay', function(){
					$(window).trigger('resize');
				});

				if ( window.location.search == '') return;

				var vars = window.location.search.substring(1).split('&'),
					query = {};

				for (var k in vars){
					var v = vars[k].split('=');
					query[ v[0] ] = v[1];
				}

				/* start from */
				if ( query.slide >= 0 ) {
					var sn = query.slide-1;
					player.find('video').bind('timeupdate', function(){
						$("[role='idx'][sn='" + sn + "']").trigger('click');

						player.find('video').unbind('timeupdate');
					});
				}

				/* autoplay */
				if ( query.autoplay == 'true' || query.autoplay == 1)
					player.find('video').prop('autoplay', true);
			}
		});

		$(window).resize(function(){

			$('#player').css({'margin-top': 0, 'padding-top' : 0});

			if ($('#player').hasClass('fullscreen')) {

				$('#player').css({
					'padding-top' : function(){
						return ($(this).height()-$(this).find('video').height()) / 2;
					}
				});
			}
			else {
				$('#player').css({
					'margin-top' : function(){
						return ($(this).height()-$(this).find('video').height()) / 2;
					}
				});

			}

		});
	});
};
